# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.2-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_networking_py_client.models
from ntnx_networking_py_client.models.OneOfnetworking.v4.config.FloatingIpProjectionassociation import FloatingIpProjectionassociation  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.FloatingIPAddress import FloatingIPAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.FloatingIp import FloatingIp  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Subnet import Subnet  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.SubnetProjection import SubnetProjection  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VmNic import VmNic  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VmNicProjection import VmNicProjection  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Vpc import Vpc  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VpcProjection import VpcProjection  # noqa: F401,E501

class FloatingIpProjection(FloatingIp):

    """

    :param subnet_projection: (:attr:`subnet_projection`) 
    :type subnet_projection: 
    :param vm_nic_projection: (:attr:`vm_nic_projection`) 
    :type vm_nic_projection: 
    :param vpc_projection: (:attr:`vpc_projection`) 
    :type vpc_projection: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'subnet_projection': 'networking.v4.config.SubnetProjection',
        'vm_nic_projection': 'networking.v4.config.VmNicProjection',
        'vpc_projection': 'networking.v4.config.VpcProjection',
        'name': 'str',
        'description': 'str',
        'association': 'OneOfnetworking.v4.config.FloatingIpassociation',
        'floating_ip': 'networking.v4.config.FloatingIPAddress',
        'external_subnet_reference': 'str',
        'external_subnet': 'networking.v4.config.Subnet',
        'private_ip': 'str',
        'floating_ip_value': 'str',
        'association_status': 'str',
        'vpc_reference': 'str',
        'vm_nic_reference': 'str',
        'vpc': 'networking.v4.config.Vpc',
        'vm_nic': 'networking.v4.config.VmNic',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'subnet_projection': 'subnetProjection',
        'vm_nic_projection': 'vmNicProjection',
        'vpc_projection': 'vpcProjection',
        'name': 'name',
        'description': 'description',
        'association': 'association',
        'floating_ip': 'floatingIp',
        'external_subnet_reference': 'externalSubnetReference',
        'external_subnet': 'externalSubnet',
        'private_ip': 'privateIp',
        'floating_ip_value': 'floatingIpValue',
        'association_status': 'AssociationStatus',
        'vpc_reference': 'vpcReference',
        'vm_nic_reference': 'vmNicReference',
        'vpc': 'vpc',
        'vm_nic': 'vmNic',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, subnet_projection=None, vm_nic_projection=None, vpc_projection=None, name=None, description=None, association=None, floating_ip=None, external_subnet_reference=None, external_subnet=None, private_ip=None, floating_ip_value=None, association_status=None, vpc_reference=None, vm_nic_reference=None, vpc=None, vm_nic=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        FloatingIp.__init__(self, name, description, association, floating_ip, external_subnet_reference, external_subnet, private_ip, floating_ip_value, association_status, vpc_reference, vm_nic_reference, vpc, vm_nic, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__subnet_projection = None
        self.__vm_nic_projection = None
        self.__vpc_projection = None
        self.discriminator = None
        if subnet_projection is not None:
            self.__subnet_projection = subnet_projection
        if vm_nic_projection is not None:
            self.__vm_nic_projection = vm_nic_projection
        if vpc_projection is not None:
            self.__vpc_projection = vpc_projection

    def _initialize_object_type(self):
        return 'networking.v4.config.FloatingIpProjection'

    def _initialize_object_version(self):
        return 'v4.r0.b1'


    @property
    def subnet_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.SubnetProjection`
        """  # noqa: E501
        return self.__subnet_projection

    @subnet_projection.setter
    def subnet_projection(self, subnet_projection):

        self.__subnet_projection = subnet_projection

    @property
    def vm_nic_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.VmNicProjection`
        """  # noqa: E501
        return self.__vm_nic_projection

    @vm_nic_projection.setter
    def vm_nic_projection(self, vm_nic_projection):

        self.__vm_nic_projection = vm_nic_projection

    @property
    def vpc_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.VpcProjection`
        """  # noqa: E501
        return self.__vpc_projection

    @vpc_projection.setter
    def vpc_projection(self, vpc_projection):

        self.__vpc_projection = vpc_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_networking_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(FloatingIpProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FloatingIpProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

