# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.2-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.AzureExternalSubnetBinding import AzureExternalSubnetBinding  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.FlowGatewayStatus import FlowGatewayStatus  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501

class FlowGateway(NetworkingBaseModel):

    """

    :param chassis_uuid: (:attr:`chassis_uuid`) Chassis UUID of the Atlas Flow Gateway.
    :type chassis_uuid: required
    :param azure_external_subnet_binding_list: (:attr:`azure_external_subnet_binding_list`) List of bindings of the Atlas Flow Gateway external subnet with the Azure external subnet.
    :type azure_external_subnet_binding_list: required
    :param gateway_status: (:attr:`gateway_status`) 
    :type gateway_status: 
    :param ovn_controller_version: (:attr:`ovn_controller_version`) Version of the OVN controller
    :type ovn_controller_version: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'chassis_uuid': 'str',
        'azure_external_subnet_binding_list': 'list[networking.v4.config.AzureExternalSubnetBinding]',
        'gateway_status': 'networking.v4.config.FlowGatewayStatus',
        'ovn_controller_version': 'str',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'chassis_uuid': 'chassisUuid',
        'azure_external_subnet_binding_list': 'azureExternalSubnetBindingList',
        'gateway_status': 'gatewayStatus',
        'ovn_controller_version': 'ovnControllerVersion',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, chassis_uuid=None, azure_external_subnet_binding_list=None, gateway_status=None, ovn_controller_version=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__chassis_uuid = None
        self.__azure_external_subnet_binding_list = None
        self.__gateway_status = None
        self.__ovn_controller_version = None
        self.discriminator = None
        self.__chassis_uuid = chassis_uuid
        self.__azure_external_subnet_binding_list = azure_external_subnet_binding_list
        if gateway_status is not None:
            self.__gateway_status = gateway_status
        if ovn_controller_version is not None:
            self.__ovn_controller_version = ovn_controller_version

    def _initialize_object_type(self):
        return 'networking.v4.config.FlowGateway'

    def _initialize_object_version(self):
        return 'v4.r0.b1'


    @property
    def chassis_uuid(self):
        """
        Chassis UUID of the Atlas Flow Gateway.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__chassis_uuid

    @chassis_uuid.setter
    def chassis_uuid(self, chassis_uuid):
        if chassis_uuid is None:
            raise ValueError("Invalid value for `chassis_uuid`, must not be `None`")  # noqa: E501
        if chassis_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', chassis_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `chassis_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__chassis_uuid = chassis_uuid

    @property
    def azure_external_subnet_binding_list(self):
        """
        List of bindings of the Atlas Flow Gateway external subnet with the Azure external subnet.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.networking.v4.config.AzureExternalSubnetBinding` ]
        """  # noqa: E501
        return self.__azure_external_subnet_binding_list

    @azure_external_subnet_binding_list.setter
    def azure_external_subnet_binding_list(self, azure_external_subnet_binding_list):
        if azure_external_subnet_binding_list is None:
            raise ValueError("Invalid value for `azure_external_subnet_binding_list`, must not be `None`")  # noqa: E501

        self.__azure_external_subnet_binding_list = azure_external_subnet_binding_list

    @property
    def gateway_status(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.FlowGatewayStatus`
        """  # noqa: E501
        return self.__gateway_status

    @gateway_status.setter
    def gateway_status(self, gateway_status):

        self.__gateway_status = gateway_status

    @property
    def ovn_controller_version(self):
        """
        Version of the OVN controller

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__ovn_controller_version

    @ovn_controller_version.setter
    def ovn_controller_version(self, ovn_controller_version):
        if ovn_controller_version is not None and not re.search('^(\\d+\\.)?(\\d+\\.)?(\\d+)$', ovn_controller_version):  # noqa: E501
            raise ValueError(r"Invalid value for `ovn_controller_version`, must be a follow pattern or equal to `/^(\\d+\\.)?(\\d+\\.)?(\\d+)$/`")  # noqa: E501

        self.__ovn_controller_version = ovn_controller_version

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(FlowGateway, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FlowGateway):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

