# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.2-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_networking_py_client.models
from ntnx_networking_py_client.models.OneOfnetworking.v4.config.GatewayProjectionservices import GatewayProjectionservices  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Gateway import Gateway  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.GatewayDeployment import GatewayDeployment  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Status import Status  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Vm import Vm  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VmProjection import VmProjection  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Vpc import Vpc  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VpcProjection import VpcProjection  # noqa: F401,E501

class GatewayProjection(Gateway):

    """

    :param vpc_projection: (:attr:`vpc_projection`) 
    :type vpc_projection: 
    :param vm_projection: (:attr:`vm_projection`) 
    :type vm_projection: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'vpc_projection': 'networking.v4.config.VpcProjection',
        'vm_projection': 'networking.v4.config.VmProjection',
        'name': 'str',
        'description': 'str',
        'vpc_reference': 'str',
        'cloud_network_reference': 'str',
        'installed_software_version': 'str',
        'supported_software_version': 'str',
        'vm_reference': 'str',
        'deployment': 'networking.v4.config.GatewayDeployment',
        'gateway_device_vendor': 'str',
        'services': 'OneOfnetworking.v4.config.Gatewayservices',
        'status': 'networking.v4.config.Status',
        'vpc': 'networking.v4.config.Vpc',
        'vm': 'networking.v4.config.Vm',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'vpc_projection': 'vpcProjection',
        'vm_projection': 'vmProjection',
        'name': 'name',
        'description': 'description',
        'vpc_reference': 'vpcReference',
        'cloud_network_reference': 'cloudNetworkReference',
        'installed_software_version': 'installedSoftwareVersion',
        'supported_software_version': 'supportedSoftwareVersion',
        'vm_reference': 'vmReference',
        'deployment': 'deployment',
        'gateway_device_vendor': 'gatewayDeviceVendor',
        'services': 'services',
        'status': 'status',
        'vpc': 'vpc',
        'vm': 'vm',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, vpc_projection=None, vm_projection=None, name=None, description=None, vpc_reference=None, cloud_network_reference=None, installed_software_version=None, supported_software_version=None, vm_reference=None, deployment=None, gateway_device_vendor=None, services=None, status=None, vpc=None, vm=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        Gateway.__init__(self, name, description, vpc_reference, cloud_network_reference, installed_software_version, supported_software_version, vm_reference, deployment, gateway_device_vendor, services, status, vpc, vm, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__vpc_projection = None
        self.__vm_projection = None
        self.discriminator = None
        if vpc_projection is not None:
            self.__vpc_projection = vpc_projection
        if vm_projection is not None:
            self.__vm_projection = vm_projection

    def _initialize_object_type(self):
        return 'networking.v4.config.GatewayProjection'

    def _initialize_object_version(self):
        return 'v4.r0.b1'


    @property
    def vpc_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.VpcProjection`
        """  # noqa: E501
        return self.__vpc_projection

    @vpc_projection.setter
    def vpc_projection(self, vpc_projection):

        self.__vpc_projection = vpc_projection

    @property
    def vm_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.VmProjection`
        """  # noqa: E501
        return self.__vm_projection

    @vm_projection.setter
    def vm_projection(self, vm_projection):

        self.__vm_projection = vm_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_networking_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(GatewayProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GatewayProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

