# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.2-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.LocalBgpService import LocalBgpService  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.LocalVpnService import LocalVpnService  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.LocalVtepService import LocalVtepService  # noqa: F401,E501

class LocalNetworkServices(object):

    """Services of this local gateway

    :param service_address: (:attr:`service_address`) 
    :type service_address: 
    :param service_addresses: (:attr:`service_addresses`) List of floating IP addresses associated with this local gateway
    :type service_addresses: 
    :param local_vpn_service: (:attr:`local_vpn_service`) 
    :type local_vpn_service: 
    :param local_vtep_service: (:attr:`local_vtep_service`) 
    :type local_vtep_service: 
    :param local_bgp_service: (:attr:`local_bgp_service`) 
    :type local_bgp_service: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'service_address': 'common.v1.config.IPAddress',
        'service_addresses': 'list[common.v1.config.IPAddress]',
        'local_vpn_service': 'networking.v4.config.LocalVpnService',
        'local_vtep_service': 'networking.v4.config.LocalVtepService',
        'local_bgp_service': 'networking.v4.config.LocalBgpService',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'service_address': 'serviceAddress',
        'service_addresses': 'serviceAddresses',
        'local_vpn_service': 'localVpnService',
        'local_vtep_service': 'localVtepService',
        'local_bgp_service': 'localBgpService',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, service_address=None, service_addresses=None, local_vpn_service=None, local_vtep_service=None, local_bgp_service=None, *args, **kwargs):  # noqa: E501
        self.__service_address = None
        self.__service_addresses = None
        self.__local_vpn_service = None
        self.__local_vtep_service = None
        self.__local_bgp_service = None
        self.discriminator = None
        if service_address is not None:
            self.__service_address = service_address
        if service_addresses is not None:
            self.__service_addresses = service_addresses
        if local_vpn_service is not None:
            self.__local_vpn_service = local_vpn_service
        if local_vtep_service is not None:
            self.__local_vtep_service = local_vtep_service
        if local_bgp_service is not None:
            self.__local_bgp_service = local_bgp_service
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.LocalNetworkServices'

    def _initialize_object_version(self):
        return 'v4.r0.b1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def service_address(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__service_address

    @service_address.setter
    def service_address(self, service_address):

        self.__service_address = service_address

    @property
    def service_addresses(self):
        """
        List of floating IP addresses associated with this local gateway

        :type:
             list[ :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__service_addresses

    @service_addresses.setter
    def service_addresses(self, service_addresses):

        self.__service_addresses = service_addresses

    @property
    def local_vpn_service(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.LocalVpnService`
        """  # noqa: E501
        return self.__local_vpn_service

    @local_vpn_service.setter
    def local_vpn_service(self, local_vpn_service):

        self.__local_vpn_service = local_vpn_service

    @property
    def local_vtep_service(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.LocalVtepService`
        """  # noqa: E501
        return self.__local_vtep_service

    @local_vtep_service.setter
    def local_vtep_service(self, local_vtep_service):

        self.__local_vtep_service = local_vtep_service

    @property
    def local_bgp_service(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.LocalBgpService`
        """  # noqa: E501
        return self.__local_bgp_service

    @local_bgp_service.setter
    def local_bgp_service(self, local_bgp_service):

        self.__local_bgp_service = local_bgp_service

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(LocalNetworkServices, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LocalNetworkServices):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

