# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.2-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.networking.v4.config.RoutingPolicy import RoutingPolicy  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.RoutingPolicyRule import RoutingPolicyRule  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VpcName import VpcName  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VpcNameProjection import VpcNameProjection  # noqa: F401,E501

class RoutingPolicyProjection(RoutingPolicy):

    """

    :param vpc_name_projection: (:attr:`vpc_name_projection`) 
    :type vpc_name_projection: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'vpc_name_projection': 'networking.v4.config.VpcNameProjection',
        'name': 'str',
        'description': 'str',
        'priority': 'int',
        'policies': 'list[networking.v4.config.RoutingPolicyRule]',
        'vpc_ext_id': 'str',
        'vpc': 'networking.v4.config.VpcName',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'vpc_name_projection': 'vpcNameProjection',
        'name': 'name',
        'description': 'description',
        'priority': 'priority',
        'policies': 'policies',
        'vpc_ext_id': 'vpcExtId',
        'vpc': 'vpc',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, vpc_name_projection=None, name=None, description=None, priority=None, policies=None, vpc_ext_id=None, vpc=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        RoutingPolicy.__init__(self, name, description, priority, policies, vpc_ext_id, vpc, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__vpc_name_projection = None
        self.discriminator = None
        if vpc_name_projection is not None:
            self.__vpc_name_projection = vpc_name_projection

    def _initialize_object_type(self):
        return 'networking.v4.config.RoutingPolicyProjection'

    def _initialize_object_version(self):
        return 'v4.r0.b1'


    @property
    def vpc_name_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.VpcNameProjection`
        """  # noqa: E501
        return self.__vpc_name_projection

    @vpc_name_projection.setter
    def vpc_name_projection(self, vpc_name_projection):

        self.__vpc_name_projection = vpc_name_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RoutingPolicyProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoutingPolicyProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

