# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.2-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.stats.DownSamplingOperator import DownSamplingOperator  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.stats.StatsQueryResponseBase import StatsQueryResponseBase  # noqa: F401,E501

class Layer2StretchStats(StatsQueryResponseBase):

    """Layer2 stretch statistics description

    :param throughput_rx_kbps: (:attr:`throughput_rx_kbps`) VPN connection string array of ingress kilobits per second values
    :type throughput_rx_kbps: 
    :param throughput_tx_kbps: (:attr:`throughput_tx_kbps`) VPN connection string array of egress kilobits per second values
    :type throughput_tx_kbps: 
    :param rtt: (:attr:`rtt`) Layer2Stretch string array of round-trip-time.
    :type rtt: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'throughput_rx_kbps': 'list[str]',
        'throughput_tx_kbps': 'list[str]',
        'rtt': 'list[str]',
        'entity_uuid': 'str',
        'stat_type': 'common.v1.stats.DownSamplingOperator',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'throughput_rx_kbps': 'throughputRxKbps',
        'throughput_tx_kbps': 'throughputTxKbps',
        'rtt': 'rtt',
        'entity_uuid': 'entityUuid',
        'stat_type': 'statType',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, throughput_rx_kbps=None, throughput_tx_kbps=None, rtt=None, entity_uuid=None, stat_type=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        StatsQueryResponseBase.__init__(self, entity_uuid, stat_type, ext_id, links, tenant_id, *args, **kwargs)
        self.__throughput_rx_kbps = None
        self.__throughput_tx_kbps = None
        self.__rtt = None
        self.discriminator = None
        if throughput_rx_kbps is not None:
            self.__throughput_rx_kbps = throughput_rx_kbps
        if throughput_tx_kbps is not None:
            self.__throughput_tx_kbps = throughput_tx_kbps
        if rtt is not None:
            self.__rtt = rtt

    def _initialize_object_type(self):
        return 'networking.v4.stats.Layer2StretchStats'

    def _initialize_object_version(self):
        return 'v4.r0.b1'


    @property
    def throughput_rx_kbps(self):
        """
        VPN connection string array of ingress kilobits per second values

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__throughput_rx_kbps

    @throughput_rx_kbps.setter
    def throughput_rx_kbps(self, throughput_rx_kbps):

        self.__throughput_rx_kbps = throughput_rx_kbps

    @property
    def throughput_tx_kbps(self):
        """
        VPN connection string array of egress kilobits per second values

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__throughput_tx_kbps

    @throughput_tx_kbps.setter
    def throughput_tx_kbps(self, throughput_tx_kbps):

        self.__throughput_tx_kbps = throughput_tx_kbps

    @property
    def rtt(self):
        """
        Layer2Stretch string array of round-trip-time.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__rtt

    @rtt.setter
    def rtt(self, rtt):

        self.__rtt = rtt

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Layer2StretchStats, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Layer2StretchStats):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

